// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from rcss3d_agent_msgs:msg/Effector.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/effector__rosidl_typesupport_fastrtps_cpp.hpp"
#include "rcss3d_agent_msgs/msg/detail/effector__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace rcss3d_agent_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rcss3d_agent_msgs::msg::HingeJointVel &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rcss3d_agent_msgs::msg::HingeJointVel &);
size_t get_serialized_size(
  const rcss3d_agent_msgs::msg::HingeJointVel &,
  size_t current_alignment);
size_t
max_serialized_size_HingeJointVel(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rcss3d_agent_msgs

namespace rcss3d_agent_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rcss3d_agent_msgs::msg::UniversalJointVel &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rcss3d_agent_msgs::msg::UniversalJointVel &);
size_t get_serialized_size(
  const rcss3d_agent_msgs::msg::UniversalJointVel &,
  size_t current_alignment);
size_t
max_serialized_size_UniversalJointVel(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rcss3d_agent_msgs

namespace rcss3d_agent_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rcss3d_agent_msgs::msg::Beam &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rcss3d_agent_msgs::msg::Beam &);
size_t get_serialized_size(
  const rcss3d_agent_msgs::msg::Beam &,
  size_t current_alignment);
size_t
max_serialized_size_Beam(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rcss3d_agent_msgs

namespace rcss3d_agent_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rcss3d_agent_msgs::msg::Say &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rcss3d_agent_msgs::msg::Say &);
size_t get_serialized_size(
  const rcss3d_agent_msgs::msg::Say &,
  size_t current_alignment);
size_t
max_serialized_size_Say(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rcss3d_agent_msgs


namespace rcss3d_agent_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rcss3d_agent_msgs
cdr_serialize(
  const rcss3d_agent_msgs::msg::Effector & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: hinge_joint_vels
  {
    size_t size = ros_message.hinge_joint_vels.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.hinge_joint_vels[i],
        cdr);
    }
  }
  // Member: universal_joint_vels
  {
    size_t size = ros_message.universal_joint_vels.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.universal_joint_vels[i],
        cdr);
    }
  }
  // Member: beams
  {
    size_t size = ros_message.beams.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.beams[i],
        cdr);
    }
  }
  // Member: says
  {
    size_t size = ros_message.says.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.says[i],
        cdr);
    }
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rcss3d_agent_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rcss3d_agent_msgs::msg::Effector & ros_message)
{
  // Member: hinge_joint_vels
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.hinge_joint_vels.resize(size);
    for (size_t i = 0; i < size; i++) {
      rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.hinge_joint_vels[i]);
    }
  }

  // Member: universal_joint_vels
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.universal_joint_vels.resize(size);
    for (size_t i = 0; i < size; i++) {
      rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.universal_joint_vels[i]);
    }
  }

  // Member: beams
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.beams.resize(size);
    for (size_t i = 0; i < size; i++) {
      rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.beams[i]);
    }
  }

  // Member: says
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.says.resize(size);
    for (size_t i = 0; i < size; i++) {
      rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.says[i]);
    }
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rcss3d_agent_msgs
get_serialized_size(
  const rcss3d_agent_msgs::msg::Effector & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: hinge_joint_vels
  {
    size_t array_size = ros_message.hinge_joint_vels.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.hinge_joint_vels[index], current_alignment);
    }
  }
  // Member: universal_joint_vels
  {
    size_t array_size = ros_message.universal_joint_vels.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.universal_joint_vels[index], current_alignment);
    }
  }
  // Member: beams
  {
    size_t array_size = ros_message.beams.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.beams[index], current_alignment);
    }
  }
  // Member: says
  {
    size_t array_size = ros_message.says.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.says[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rcss3d_agent_msgs
max_serialized_size_Effector(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: hinge_joint_vels
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_HingeJointVel(
        full_bounded, current_alignment);
    }
  }

  // Member: universal_joint_vels
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_UniversalJointVel(
        full_bounded, current_alignment);
    }
  }

  // Member: beams
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Beam(
        full_bounded, current_alignment);
    }
  }

  // Member: says
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Say(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _Effector__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rcss3d_agent_msgs::msg::Effector *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _Effector__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rcss3d_agent_msgs::msg::Effector *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _Effector__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rcss3d_agent_msgs::msg::Effector *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _Effector__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_Effector(full_bounded, 0);
}

static message_type_support_callbacks_t _Effector__callbacks = {
  "rcss3d_agent_msgs::msg",
  "Effector",
  _Effector__cdr_serialize,
  _Effector__cdr_deserialize,
  _Effector__get_serialized_size,
  _Effector__max_serialized_size
};

static rosidl_message_type_support_t _Effector__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_Effector__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace rcss3d_agent_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rcss3d_agent_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rcss3d_agent_msgs::msg::Effector>()
{
  return &rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::_Effector__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rcss3d_agent_msgs, msg, Effector)() {
  return &rcss3d_agent_msgs::msg::typesupport_fastrtps_cpp::_Effector__handle;
}

#ifdef __cplusplus
}
#endif
